%bcond_without check
# rust-srpm-macros is used to provide macros.rust-srpm files.
# ocs currently offers rust-srpm-macros subpackages via rust-toolset, not rust-packaging
%bcond_with prov_rust_srpm_macro

Summary:        RPM macros and generators for building Rust packages
Name:           rust-packaging
Version:        26.3
Release:        3%{?dist}
License:        MIT
URL:            https://pagure.io/fedora-rust/rust-packaging
Source0:        %{url}/archive/%{version}/rust-packaging-%{version}.tar.gz

# %%cargo_prep macro in rust-packaging accepts a -V flag
Patch0001:      0001-Temporarily-accept-cargo_prep-V-flag-for-spec-compat.patch

# remove Spaces at the end of CFLAGS, CXXFLAGS, LDFLAGS in test
Patch5000:      0001-fix-test_cargo_prep-in-check.patch

BuildArch:      noarch

%if %{with check}
BuildRequires:  python3-pytest
%endif

%description
RPM macros and generators for building Rust packages

%if %{with prov_rust_srpm_macro}
%package -n rust-srpm-macros
Summary:        RPM macros for building Rust projects

%description -n rust-srpm-macros
RPM macros for building source packages for Rust projects.
%endif


%package -n cargo-rpm-macros
Summary:        RPM macros for building projects with cargo

Requires:       cargo
Requires:       cargo2rpm >= 0.1.8
Requires:       gawk grep
%if %{with prov_rust_srpm_macro}
Requires:       rust-srpm-macros = %{version}-%{release}
%else
# 1. "rust-srpm-macros" package is built from other source package, so it is a different version.
# 2. macros.rust file conflicts with rust-srpm-macros-24.
#    but it can not replace rust-srpm-macros-24, so do not set Obsoletes tag.
Requires:       rust-srpm-macros > 24
%endif

Provides:       rust-packaging = %{version}-%{release}
# cargo_vendor.attr conflicts 
Conflicts:      rust-toolset

%description -n cargo-rpm-macros
RPM macros for building projects with cargo.

%prep
%autosetup -p1

%build

%install
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.cargo
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.rust
%if %{with prov_rust_srpm_macro}
install -D -p -m 0644 -t %{buildroot}/%{_rpmmacrodir} macros.d/macros.rust-srpm
%endif
install -D -p -m 0644 -t %{buildroot}/%{_fileattrsdir} fileattrs/cargo.attr
install -D -p -m 0644 -t %{buildroot}/%{_fileattrsdir} fileattrs/cargo_vendor.attr

%if %{with check}
%check
export MACRO_DIR=%{buildroot}%{_rpmmacrodir}
pytest -vv %{!?with_prov_rust_srpm_macro: --ignore=tests/test_macros_rust_srpm.py }
%endif

%if %{with prov_rust_srpm_macro}
%files -n rust-srpm-macros
%license LICENSE
%{_rpmmacrodir}/macros.rust
%{_rpmmacrodir}/macros.rust-srpm
%endif

%files -n cargo-rpm-macros
%license LICENSE
%{_rpmmacrodir}/macros.cargo
%if %{without prov_rust_srpm_macro}
%{_rpmmacrodir}/macros.rust
%endif
%{_fileattrsdir}/cargo.attr
%{_fileattrsdir}/cargo_vendor.attr

%changelog
* Mon Jul 8 2024 Wang Guodong <gordonwwang@tencent.com> - 26.3-3
- remvoe obsoletes tag, restriction by version of rust-srpm-macros

* Mon Jul 8 2024 Wang Guodong <gordonwwang@tencent.com> - 26.3-2
- obsoletes rust-srpm-macros(rust-packaging)

* Wed Jun 26 2024 Wang Guodong <gordonwwang@tencent.com> - 26.3-1
- Upgrade to version 26.3
- enable check
- not provides rust-srpm-macros

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 24-6
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Jul 18 2023 Wang Guodong <gordonwwang@tencent.com> - 24-5
- Rebuilt for rust 1.69.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 24-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 24-3
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 23 2023 Yi Lin <nilusyi@tencent.com> - 24-2
- add provides rust-packaging.

* Wed Mar 22 2023 Yi Lin <nilusyi@tencent.com> - 24-1
- package init.
